#!/usr/bin/perl

#This program rum as a standalone at any Mac system.
#Uses:perl subnucpred.pl Input_fasta_file Threshold.
#User can submit more than one protein sequences at a time in fasta format only.
#Result will be formed in Prediction file.

open(SEQ_FILE,"$ARGV[0]") or die "$!";
open(INP,">input_seq.fasta") or die "$!";
while ($in=<SEQ_FILE>)
{
    chomp ($in);
    print INP "$in\n";
}
close INP;
close SEQ_FILE;

system "/usr/bin/tr -d '\r' <input_seq.fasta >input.fasta";
system "/bin/grep '>' input.fasta |/usr/bin/cut -d '|' -f3 |/usr/bin/cut -d ' ' -f1 >protein_id";
system "pseb2-linux/src/pseb -a -i input.fasta -l 1 -o pseaacom -w 0.05 -t 0";
system "/bin/sed -e 's/^0/+1/g' pseaacom |/usr/bin/cut -d '#' -f1 >pseaacom_out";
system "/usr/local/bin/svm_classify pseaacom_out Models/model_level1 svm_score_level1";
system "/usr/local/bin/svm_classify pseaacom_out Models/model_classA svm_score_classA";
system "/usr/local/bin/svm_classify pseaacom_out Models/model_classB svm_score_classB";
system "/usr/local/bin/svm_classify pseaacom_out Models/model_classC svm_score_classC";
system "/usr/local/bin/svm_classify pseaacom_out Models/model_classD svm_score_classD";
system "/usr/bin/paste protein_id pseaacom_out svm_score_level1 svm_score_classA svm_score_classB svm_score_classC svm_score_classD |/usr/bin/tr '\t' '#' >final";

open(PREDICTION,">>Prediction") or die "$!";
print PREDICTION "Protein ID\tPrediction\n";
close PREDICTION;
open(FINAL,"final") or die "$!";
while($line=<FINAL>)
{
    chomp($line);
    @svm=split(/\#/,$line);
    #print "=====$svm[2]\n";
    
    #if(($svm[2] < $svm[3])||($svm[2] < $svm[4])||($svm[2] < $svm[5])||($svm[2] < $svm[6]))#Level1 prediction
    if($svm[2] < $ARGV[1])
    {
	print "Non-Betalactamase\n";
	open(PREDICTION,">>Prediction") or die "$!";
	print PREDICTION "$svm[0]\tNon-Betalactamase\n";
	close PREDICTION;
    }
    else#Level2 prediction
    {
	#print "Betalactamase\n"
	if(($svm[3] >= $svm[4])&&($svm[3] >= $svm[5])&&($svm[3] >= $svm[6]))
	{
	    print "Class A Betalactamase\n";
	    open(PREDICTION,">>Prediction") or die "$!";
	    print PREDICTION "$svm[0]\tClass A Betalactamase\n";
	    close PREDICTION;
	}
	if(($svm[4] >= $svm[3])&&($svm[4] >= $svm[5])&&($svm[4] >= $svm[6]))
	{
	    print "Class B Betalactamase\n";
	    open(PREDICTION,">>Prediction") or die "$!";
	    print PREDICTION "$svm[0]\tClass B Betalactamase\n";
	    close PREDICTION;
	}
	if(($svm[5] >= $svm[3])&&($svm[5] >= $svm[4])&&($svm[5] >= $svm[6]))
	{
	    print "Class C Betalactamase\n";
	    open(PREDICTION,">>Prediction") or die "$!";
	    print PREDICTION "$svm[0]\tClass C Betalactamase\n";
	    close PREDICTION;
	}
	if(($svm[6] >= $svm[3])&&($svm[6] >= $svm[4])&&($svm[6] >= $svm[5]))
	{
	    print "Class D Betalactamase\n";
	    open(PREDICTION,">>Prediction") or die "$!";
	    print PREDICTION "$svm[0]\tClass D Betalactamase\n";
	    close PREDICTION;
	}
    }
}
close FINAL;
system "rm input_seq.fasta input.fasta final protein_id pseaacom pseaacom_out svm_score_level1 svm_score_classA svm_score_classB svm_score_classC svm_score_classD";
